// Sterownik LED RGB 3W
// main.c program gwny

#include <avr\io.h>
#include <stdio.h>
#include <inttypes.h>
#include <avr\pgmspace.h>
#include <avr\eeprom.h>
#include <avr\interrupt.h>
#include <string.h>

#include "harddef.h"
#include "delay.h"
#include "makra.h"
#include "i2c.h"
#include "lcd.h"

#include "zmienne.c"
#include "delay.c"
#include "funkcje.c"

int main(void)
{
	// konfiguracja procesora
	DDRC = 1<<LCD_E | 1<<LCD_RS | 0x0F<<LCD_D4;
	lcd_init();
	lcd_cls();
	lcd_def_sym();
	
	DDRD = ~(1<<gr | 1<<dl | 1<<ok | 1<<me);
	PORTD = 255;

	DDRB = 255;
	PORTB = 255;
	
	TCCR0 = 4;				
	
	TCNT1 = 62411;			
	TIMSK = 1<<TOIE1 | 1<<TOIE0;
	TCCR1B = 4;				
	sei();
	
	lcd_str_P((prog_char*)PSTR(" Sterownik RGB"));
	delayms16(400);
	
	// odczyt eeprom
	br_r = eeprom_read_byte(1); if(br_r == 255) br_r = 100;
	br_g = eeprom_read_byte(2); if(br_g == 255) br_g = 100;
	br_b = eeprom_read_byte(3); if(br_b == 255) br_b = 100;
	
	br_rgb = eeprom_read_byte(4); if(br_rgb == 255) br_rgb = 100;

	kw_rgb = eeprom_read_byte(5); if(kw_rgb == 255) kw_rgb = 50;
	T_rgb = eeprom_read_byte(6); if(T_rgb == 255) T_rgb = 12;
	
	wyb1 = eeprom_read_byte(7); if(wyb1 == 255) wyb1 = 1;
	wyb3 = eeprom_read_byte(8); if(wyb3 == 255) wyb3 = 1;
	
	// konfiguracja PCA9633
	cli();
	i2c_start();
	i2c_send(0b11000100);
	i2c_send(0b10000000);
	i2c_send(0);
	i2c_send(0b00000100);		
	i2c_stop();	
	sei();
	delay100us8(100); 			
	
	cli();
	i2c_start();
	i2c_send(0b11000100);
	i2c_send(0b00001000);
	i2c_send(0b10101010);
	i2c_stop();
	sei();
	delay100us8(100);
	
	cli();
	i2c_start();
	i2c_send(0b11000100);
	i2c_send(0b10100010);
	i2c_send(pr_byte(br_r));
	i2c_send(pr_byte(br_g));
	i2c_send(pr_byte(br_b));
	i2c_stop();
	sei();
	delay100us8(100);
	
	// ptla gwna
	for(;;)
	{
		// menu
		switch (str)
		{
			// cz 1
			case 0:
				lcd_home();
				
				lcd_str_P((prog_char*)PSTR("  Jasno"));
				lcd_sp(0);
				lcd_sp(1);
				lcd_str_P((prog_char*)PSTR(" [%]   "));
				
				lcd_command(LCDC_DDA | 64);		
				
				lcd_str_P((prog_char*)PSTR(" R"));
				if(wyb1 == 1 && mig == 0 && szyb_przes == 0)
				{
					lcd_str_P((prog_char*)PSTR("   "));
				}
				else
				{
					if(br_r < 100 & br_r > 9) lcd_str_P((prog_char*)PSTR(" "));
					if(br_r < 10) lcd_str_P((prog_char*)PSTR("  "));
					lcd_dec(br_r);
				}
				
				lcd_str_P((prog_char*)PSTR(" G"));
				if(wyb1 == 2 && mig == 0 && szyb_przes == 0)
				{
					lcd_str_P((prog_char*)PSTR("   "));
				}
				else
				{
					if(br_g < 100 & br_g > 9) lcd_str_P((prog_char*)PSTR(" "));
					if(br_g < 10) lcd_str_P((prog_char*)PSTR("  "));
					lcd_dec(br_g);
				}
				
				lcd_str_P((prog_char*)PSTR(" B"));
				if(wyb1 == 3 && mig == 0 && szyb_przes == 0)
				{
					lcd_str_P((prog_char*)PSTR("   "));
				}
				else
				{
					if(br_b < 100 & br_b > 9) lcd_str_P((prog_char*)PSTR(" "));
					if(br_b < 10) lcd_str_P((prog_char*)PSTR("  "));
					lcd_dec(br_b);
				}
				lcd_str_P((prog_char*)PSTR(" "));
				
				if(!(PIND & 1<<gr) && kl_act == 1)
				{
					kl = 1;
					kl_act = 0;
					c_10ms = 0;
					
					if(wyb1 == 1){	br_r++;	if(br_r >= 101) br_r = 0; }
					if(wyb1 == 2){ br_g++; if(br_g >= 101) br_g = 0; }
					if(wyb1 == 3){ br_b++;	if(br_b >= 101) br_b = 0; }
					br_up();
				}
					
				if(!(PIND & 1<<dl) && kl_act == 1)
				{
					kl = 1;
					kl_act = 0;
					c_10ms = 0;
					
					if(wyb1 == 1){ br_r--; if(br_r >= 101) br_r = 100; }
					if(wyb1 == 2){ br_g--; if(br_g >= 101) br_g = 100; }
					if(wyb1 == 3){ br_b--; if(br_b >= 101) br_b = 100; }
					br_up();
				}
				
				if(!(PIND & 1<<ok) && kl_ok == 0)
				{
					kl_ok = 1;
					
					wyb1++;
					if(wyb1 >= 4) wyb1 = 0;
					eeprom_write_byte(7, wyb1);
				}
				
				if(!(PIND & 1<<me) && kl_me == 0)
				{
					kl_me = 1;
					str = 1;
					
					cli();
					i2c_start();
					i2c_send(0b11000100);
					i2c_send(0b00000110);
					i2c_send(pr_byte(br_rgb));
					i2c_stop();
					sei();
					delay100us8(100);
					
					cli();
					i2c_start();
					i2c_send(0b11000100);
					i2c_send(0b00001000);
					i2c_send(255);
					i2c_stop();
					sei();
					delay100us8(100);
				}
				
			break;
			
			// cz 2
			case 1:
				lcd_home();
				
				lcd_str_P((prog_char*)PSTR("  Jasno"));
				lcd_sp(0);
				lcd_sp(1);
				lcd_str_P((prog_char*)PSTR(" [%]   "));
				
				lcd_command(LCDC_DDA | 64);	
				
				lcd_str_P((prog_char*)PSTR("    RGB "));
				
				if(br_rgb < 100 & br_rgb > 9) lcd_str_P((prog_char*)PSTR(" "));
				if(br_rgb < 10) lcd_str_P((prog_char*)PSTR("  "));
				lcd_dec(br_rgb);
				lcd_str_P((prog_char*)PSTR("     "));
				
				if(!(PIND & 1<<gr) && kl_act == 1)
				{
					kl = 1;
					kl_act = 0;
					c_10ms = 0;
					br_rgb++;
					if(br_rgb >= 101) br_rgb = 0;
					brg_up();
				}
				
				if(!(PIND & 1<<dl) && kl_act == 1)
				{
					kl = 1;
					kl_act = 0;
					c_10ms = 0;
					br_rgb--;
					if(br_rgb >= 101) br_rgb = 100;
					brg_up();
				}
					
				if(!(PIND & 1<<me) && kl_me == 0)
				{
					kl_me = 1;
					
					cli();
					i2c_start();
					i2c_send(0b11000100);
					i2c_send(0b00000001);
					i2c_send(0b00100100);
					i2c_stop();
					sei();
					delay100us8(100);
					
					cli();
					i2c_start();
					i2c_send(0b11000100);
					i2c_send(0b10000110);
					i2c_send(pr_byte(kw_rgb));
					i2c_send(dzs_b(T_rgb));
					i2c_stop();
					sei();
					delay100us8(100);
						
					str = 2;
				}
			break;
			
			// cz 3
			case 2:
				lcd_home();
				
				lcd_str_P((prog_char*)PSTR("    Miganie     "));
				
				lcd_command(LCDC_DDA | 64);	
				
				lcd_str_P((prog_char*)PSTR("kw "));
				
				if(wyb3 == 1 && mig == 0 && szyb_przes == 0)
				{
					lcd_str_P((prog_char*)PSTR("   "));
				}
				else
				{
					if(kw_rgb < 100 & kw_rgb > 9) lcd_str_P((prog_char*)PSTR(" "));
					if(kw_rgb < 10) lcd_str_P((prog_char*)PSTR("  "));
					lcd_dec(kw_rgb);
				}
				
				lcd_str_P((prog_char*)PSTR("% T "));
				
				if(wyb3 == 2 && mig == 0 && szyb_przes == 0)
				{
					lcd_str_P((prog_char*)PSTR("    "));
				}
				else
				{
					if(T_rgb >= 100) { lcd_dec(T_rgb/10); lcd_str_P((prog_char*)PSTR(".")); lcd_dec(T_rgb%10);}
					if(T_rgb >= 10 && T_rgb < 100) { lcd_str_P((prog_char*)PSTR(" ")); lcd_dec(T_rgb/10); lcd_str_P((prog_char*)PSTR(".")); lcd_dec(T_rgb%10);}
					if(T_rgb < 10) { lcd_str_P((prog_char*)PSTR(" 0.")); lcd_dec(T_rgb);}
				}
				lcd_str_P((prog_char*)PSTR("s "));
				
				if(!(PIND & 1<<gr) && kl_act == 1)
				{
					kl = 1;
					kl_act = 0;
					c_10ms = 0;
					if(wyb3 == 1){ kw_rgb++; if(kw_rgb >= 101) kw_rgb = 0;}
					if(wyb3 == 2){ T_rgb++; if(T_rgb >= 108) T_rgb = 4;}
					blg_up();
				}
					
				if(!(PIND & 1<<dl) && kl_act == 1)
				{
					kl = 1;
					kl_act = 0;
					c_10ms = 0;
					if(wyb3 == 1){ kw_rgb--; if(kw_rgb >= 101) kw_rgb = 100;}
					if(wyb3 == 2){ T_rgb--; if(T_rgb <= 3) T_rgb = 107;}
					blg_up();
				}
				
				if(!(PIND & 1<<ok) && kl_ok == 0)
				{
					kl_ok = 1;
					
					wyb3++;
					if(wyb3 >= 3) wyb3 = 0;
					
					eeprom_write_byte(8, wyb3);
				}
				
				if(!(PIND & 1<<me) && kl_me == 0)
				{
					kl_me = 1;
					
					cli();
					i2c_start();
					i2c_send(0b11000100);
					i2c_send(0b10000000);
					i2c_send(0);
					i2c_send(0b00000100);
					i2c_send(pr_byte(br_r));
					i2c_send(pr_byte(br_g));
					i2c_send(pr_byte(br_b));
					i2c_stop();
					sei();
					delay100us8(100);
					
					cli();
					i2c_start();
					i2c_send(0b11000100);
					i2c_send(0b00000110);
					i2c_send(255);
					i2c_stop();
					sei();
					delay100us8(100);
					
					cli();
					i2c_start();
					i2c_send(0b11000100);
					i2c_send(0b00001000);
					i2c_send(0b10101010);
					i2c_stop();
					sei();
					delay100us8(100);
					
					str = 0;
				}
			break;
		}
		
		// przyciski
		if(PIND & 1<<gr && PIND & 1<<dl)
		{
			kl = 0;
			szyb_przes = 0;
			co200ms = 0;	
			
			switch (str)
			{
				case 0:
					if(wyb1 == 1) eeprom_write_byte(1, br_r);
					if(wyb1 == 2) eeprom_write_byte(2, br_g);
					if(wyb1 == 3) eeprom_write_byte(3, br_b);
				break;
				
				case 1:
					eeprom_write_byte(4, br_rgb);
				break;
				
				case 2:
					if(wyb3 == 1) eeprom_write_byte(5, kw_rgb);
					if(wyb3 == 2) eeprom_write_byte(6, T_rgb);
				break;
			}	
		}	
		
		if(PIND & 1<<ok && kl_ok == 1)
		{
			kl_ok = 0;
		}
		
		if(PIND & 1<<me && kl_me == 1)
		{
			kl_me = 0;
		}
	}
	return 0;
}	

// timer 0 opnienia
ISR(TIMER0_OVF_vect)
{
	TCNT0 = 100;		
	c_10ms++;
	if(c_10ms >= 25 && szyb_przes == 0)
	{
		kl_act = 1;
		c_10ms = 0;
	}
	
	if(c_10ms >= 4 && szyb_przes == 1)
	{
		kl_act = 1;
		c_10ms = 0;
	}
		
}

// timer 1 opnienia
ISR(TIMER1_OVF_vect)
{
	TCNT1 = 62411;		
	
	if(kl == 1 && szyb_przes == 0) co200ms++;
	if(co200ms >= 6) szyb_przes = 1;
	
	mig1++;
	if(mig1 >= 2)
	{
		mig = 1;
	}
	if(mig1 >= 4)
	{
		mig = 0;
		mig1 = 0;
	}
	
}
